module Repmin where

import Prelude hiding (zip)
import TreeZipper

sres :: Loc Tree -> Tree
sres l = case (value l)
       	    of Leaf v -> Leaf (ival l)
	       _ -> Fork (sres (left l)) (sres (right l))

ival :: Loc Tree -> Int
ival l  = if (isRoot l)
	         then smin l 
	         else ival (parent l)

smin :: Loc Tree -> Int
smin l = case (value l)
       	    of Leaf v -> v
	       _ ->  (smin (left l)) `min` (smin (right l))

transform :: Tree -> Tree
transform t = sres (zip t)

